#include "DSP28x_Project.h"

#define  CS GpioDataRegs.GPBDAT.bit.GPIO52	//ŶCSλ

void spi_xmit(Uint16 a);
void spi_fifo_init(void);
void spi_init(void);
void delayUs(Uint16 Tus);
void delayMs(Uint16 Tms);
void error(void);
Uint16 Read_INCL_OUT(void);				//ȡADIS16203޷ŽǶȼĴINCL_OUTֵ
Uint16 Read_INCL_NULL(void);			//ȡIncline null calibrationֵ(бУ)
void Init_INCL(void);					//ܣ  üĴдICFlash,SPIַSPI_INCLINOMETER_BASE
void Init_AVG_CNT(void);
void Init_SMPL_TIME(void);
void Init_FLASH_UPDATE(void);
Uint16 Read_spi_command(Uint16 Address);
void   Write_spi_command(Uint16 Address,Uint16 write_data);

void main(void)
{
	Uint16 receve_data = 0;
	InitSysCtrl();
	InitSpiaGpio();

	DINT;
	InitPieCtrl();
	IER = 0x0000;
	IFR = 0x0000;
   
	InitPieVectTable();
	spi_fifo_init();	  			//ʼ SpiFIFO
	spi_init();		  				//ʼ SPI
	//Init_INCL();					//üĴдICFlash

	for(;;)
	{
		receve_data = Read_INCL_OUT();
		if(receve_data==0)
		{;;}
	}
}

void delayMs(Uint16 Tms)   						//Ϊλʱ
{
	Uint16 i;
	while(Tms-- != 0)
	{
		i = 4;
		while(i-- != 0)
		DELAY_US(250);
	}
}
void error(void)
{
    asm("     ESTOP0");
    for (;;);
}

void spi_init()
{
	SpiaRegs.SPICCR.all =0x00CF;	             // ã½룬طͣ16λַλ
	SpiaRegs.SPICTL.all =0x000E;			     // ģʽ,CLKźӳٰڣ1110

	SpiaRegs.SPIBRR =0x0013;					 // ,1M
    SpiaRegs.SPIPRI.bit.FREE = 1;                // ģʽĶϵ㲻Ҫŷ
}

void spi_xmit(Uint16 a)
{
    SpiaRegs.SPITXBUF = a;					 	 //8λ16λ
}

void spi_fifo_init()										
{
    SpiaRegs.SPIFFTX.all=0xE040;
    SpiaRegs.SPIFFRX.all=0x2044;
    SpiaRegs.SPIFFCT.all=0x0;
}

// ܣ  ȡADIS16203޷ŽǶȼĴINCL_OUTֵ
// SPIҪʵĻַSPI_INCLINOMETER_BASE	ֵUint16 nINCL_OUT
Uint16 Read_INCL_OUT(void)						//ȡ޷ŽǶȼĴֵ
{
	Uint16 nINCL_OUT = 0;						//ĽǶȼĴֵ
	Uint16  Address = 0x0D;						//д

	nINCL_OUT = Read_spi_command(Address);		//ͨSPIд
	nINCL_OUT = 0x3FFF & nINCL_OUT;             //ȥNDEAλ
	return nINCL_OUT;
}

// ܣ  üĴдICFlash
// SPIַSPI_INCLINOMETER_BASE
Uint16 Read_spi_command(Uint16 Address)
{
	Uint8 i;
	//Uint16 clear_data = 0;
	Uint16 Register_data = 0;

	CS = 1;
	DELAY_US(20);
	Address = Address<<8;
	//spi_xmit(0x0000);										//αָ
	//clear_data = SpiaRegs.SPIRXBUF;						//նBUFF
	//asm(" NOP");											//ִһ null opreation ʱ

	for(i=0;i<2;i++)
	{
		CS = 0;												//дǰCS
		DELAY_US(20);
		spi_xmit(Address);									//йؼĴĵֵַд,ܹд16λ
		DELAY_US(150);
		CS = 1;												//дCS
		DELAY_US(20);
	}
	//while(SpiaRegs.SPISTS.bit.INT_FLAG != 1) { }			//Դ豸
	while(SpiaRegs.SPIFFRX.bit.RXFFST !=1) { } 				//Դ豸
		Register_data = SpiaRegs.SPIRXBUF;					//ϴ
	DELAY_US(20);

	return Register_data;									//ļĴֵصϲ㺯
}

void Write_spi_command(Uint16 Address,Uint16 write_data)
{
	Uint16 write_Register = 0;								//дĴ16λ

	CS = 0;													//дǰCS
	DELAY_US(20);
	Address = Address|0X80;									//λΪ1ʾдλΪĴַ10111111
	write_Register = (Address<<8)+write_data;				//16λ֡
	spi_xmit(write_Register);								//16λйؼĴ֡д,ܹд16λ
	CS = 1;													//дCS
	DELAY_US(20);
}

// ܣ  ȡIncline null calibrationֵ(бУ)
// SPIҪʵĻַSPI_INCLINOMETER_BASE    ֵUint16 nINCL_NULL
// У׼Ĵ
Uint16 Read_INCL_NULL(void)
{
	Uint16 nINCL_NULL = 0;
	Uint8  Address = 0x18;

	nINCL_NULL = Read_spi_command(Address);	  	  //ͨSPIд
	nINCL_NULL = 0x3FFF & nINCL_NULL;             //ȥ2λ
	return nINCL_NULL;
}

void Init_INCL(void)
{
	Init_AVG_CNT();								//AVG_CNTĴֵ
	Init_SMPL_TIME();							//SMPL_TIMEĴֵ()
	Init_FLASH_UPDATE();						//FLASHĴֵ
}

// ܣ  òAVG_CNTĴֵ(ƶƽ˲)
// SPIַSPI_INCLINOMETER_BASE, AVG_CNTĴֵ
void Init_AVG_CNT(void)
{
	Uint8  Address = 0x38;
	Uint8  Init_command = 0x08;					//ʼҪд
	Uint16 nResult = 0;

	nResult = Read_spi_command(Address);
	if(nResult!=0x08)							//ԤֵдĴ
	{
		Write_spi_command(Address,Init_command);	//ʼдĴ
	}
	//return nResult;								//AVG_CNTĴֵ
}

// ܣ  òSMPL_TIMEĴֵ()
// SPIַSPI_INCLINOMETER_BASE,    ֵSMPL_TIMEĴֵ
void Init_SMPL_TIME(void)
{
	Uint8  Address = 0x36;
	Uint8  Init_Command = 0x08;					//ʼҪд
	Uint16 nResult = 0;

	nResult = Read_spi_command(Address);
	if(nResult!=0x08)//ԤֵдĴ
	{
		//nCommand[0]= 0x36 | 0x80;
		//nCommand[1]= 0x13;  					//(19-1)*122.1+244.2=2,442 us
		/*The overall acquisition time can be varied from 244.2 s to 15.51 ms in 122.1 s
      	  increments for TMBS = 0 and from 7.57 ms to 481 ms in 3.784 ms increments for TMBS = 1 */
		Write_spi_command(Address,Init_Command);
	}
	//return Result;
}

void Init_FLASH_UPDATE(void)					//ʼFLASH
{
	Uint8  Address = 0x3E;						//üĴַ
	Uint8  Init_Command = 0x04;					//ʼҪд

	Write_spi_command(Address,Init_Command);
}
